<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/transaction_manager_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/15/85  transaction_manager_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>Entry points in transaction_manager_ begin and end transactions on
<span id="L5" class="LineNr">  5 </span>behalf of users, return information about transactions, and recover
<span id="L6" class="LineNr">  6 </span>transactions after system failure.
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>Entry points in transaction_manager_:
<span id="L10" class="LineNr"> 10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>:Entry:  abandon_txn:  03/15/85 transaction_manager_$abandon_txn
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Function:  This entry point relinquishes control of the current
<span id="L17" class="LineNr"> 17 </span>transaction, causing it to be adjusted <span class="textRainbow_lv0_p0">(</span>aborted unless a commit was
<span id="L18" class="LineNr"> 18 </span>already in progress<span class="textRainbow_lv0_p0">)</span> by the DM daemon <span class="textRainbow_lv0_p0">(</span>Data_Management.Daemon<span class="textRainbow_lv0_p0">)</span>.  The
<span id="L19" class="LineNr"> 19 </span>caller is immediately given a new TDT entry and can begin another
<span id="L20" class="LineNr"> 20 </span>transaction.
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Syntax:
<span id="L24" class="LineNr"> 24 </span>declare transaction_manager_$abandon_txn entry <span class="textRainbow_lv0_p0">(</span>bit <span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L25" class="LineNr"> 25 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>call transaction_manager_$abandon_txn <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>
<span id="L29" class="LineNr"> 29 </span>Arguments:
<span id="L30" class="LineNr"> 30 </span>txn_id
<span id="L31" class="LineNr"> 31 </span>   is the identifier of the current transaction, or &quot;0&quot;b to default to
<span id="L32" class="LineNr"> 32 </span>   the current transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If txn_id is neither &quot;0&quot;b nor the
<span id="L33" class="LineNr"> 33 </span>   transaction identifier of the current transaction,
<span id="L34" class="LineNr"> 34 </span>   dm_error_$transaction_not_current is returned.  This argument can be
<span id="L35" class="LineNr"> 35 </span>   used as a check to be sure which transaction is being abandoned.
<span id="L36" class="LineNr"> 36 </span>code
<span id="L37" class="LineNr"> 37 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>:Entry:  abort_txn:  03/15/85 transaction_manager_$abort_txn
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>Function:  This entry point aborts the current transaction, returning
<span id="L44" class="LineNr"> 44 </span>all modified DM files to the state they were in before the transaction
<span id="L45" class="LineNr"> 45 </span>began.
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>Syntax:
<span id="L49" class="LineNr"> 49 </span>declare transaction_manager_$abort_txn entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L50" class="LineNr"> 50 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L51" class="LineNr"> 51 </span>call transaction_manager_$abort_txn <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>Arguments:
<span id="L55" class="LineNr"> 55 </span>txn_id
<span id="L56" class="LineNr"> 56 </span>   is the identifier of the current transaction, or &quot;0&quot;b to default to
<span id="L57" class="LineNr"> 57 </span>   the current transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If txn_id is neither &quot;0&quot;b nor the
<span id="L58" class="LineNr"> 58 </span>   transaction identifier of the current transaction,
<span id="L59" class="LineNr"> 59 </span>   dm_error_$transaction_not_current is returned.  This argument can be
<span id="L60" class="LineNr"> 60 </span>   used as a check to be sure which transaction is being aborted.
<span id="L61" class="LineNr"> 61 </span>code
<span id="L62" class="LineNr"> 62 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L63" class="LineNr"> 63 </span>
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>Notes:  If the transaction has already been abandoned, this entry point
<span id="L66" class="LineNr"> 66 </span>causes the DM daemon to abort it immediately.
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>This entry point will retry abort of a transaction that was left in an
<span id="L69" class="LineNr"> 69 </span>error state by a previous abort or rollback.  It will not attempt abort
<span id="L70" class="LineNr"> 70 </span>of a transaction left in error by any other operation.
<span id="L71" class="LineNr"> 71 </span>
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>:Entry:  begin_txn:  03/15/85 transaction_manager_$begin_txn
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>Function:  This entry point begins a transaction on behalf of the
<span id="L77" class="LineNr"> 77 </span>caller, by generating a unique transaction identifier and recording it
<span id="L78" class="LineNr"> 78 </span>in a TDT entry as the current transaction for the process.  Other
<span id="L79" class="LineNr"> 79 </span>information, such as owner name, begin time, and transaction state
<span id="L80" class="LineNr"> 80 </span><span class="textRainbow_lv0_p0">(</span>in-progress<span class="textRainbow_lv0_p0">)</span> are also recorded.  The transaction id is passed to the
<span id="L81" class="LineNr"> 81 </span>before journal manager to begin the transaction.
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Syntax:
<span id="L85" class="LineNr"> 85 </span>declare transaction_manager_$begin_txn <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>17<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span>
<span id="L86" class="LineNr"> 86 </span>     aligned<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L87" class="LineNr"> 87 </span>call transaction_manager_$begin_txn <span class="textRainbow_lv0_p0">(</span>begin_mode<span class="textRainbow_lv0_o0">,</span>
<span id="L88" class="LineNr"> 88 </span>     before_journal_opening_id<span class="textRainbow_lv0_o0">,</span> txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>Arguments:
<span id="L92" class="LineNr"> 92 </span>begin_mode
<span id="L93" class="LineNr"> 93 </span>   determines which of several protocols to use.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The only mode
<span id="L94" class="LineNr"> 94 </span>   currently available is normal mode.
<span id="L95" class="LineNr"> 95 </span>   TM_NORMAL_MODE
<span id="L96" class="LineNr"> 96 </span>      requires locks to accompany all gets and puts, and requires all
<span id="L97" class="LineNr"> 97 </span>      updates to be journalized.
<span id="L98" class="LineNr"> 98 </span>before_journal_opening_id
<span id="L99" class="LineNr"> 99 </span>   is the opening identifier of the before journal to be used by this
<span id="L100" class="LineNr">100 </span>   transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If zero, a before journal is assigned by
<span id="L101" class="LineNr">101 </span>   default to this transaction.
<span id="L102" class="LineNr">102 </span>txn_id
<span id="L103" class="LineNr">103 </span>   is the identifier of the newly created transaction.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It is
<span id="L104" class="LineNr">104 </span>   generated by transaction_manager_$begin_txn and is guaranteed to be
<span id="L105" class="LineNr">105 </span>   unique across all Multics systems.  Transaction identifiers are not
<span id="L106" class="LineNr">106 </span>   reusable.
<span id="L107" class="LineNr">107 </span>code
<span id="L108" class="LineNr">108 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L109" class="LineNr">109 </span>
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>:Entry:  commit_txn:  03/15/85 transaction_manager_$commit_txn
<span id="L112" class="LineNr">112 </span>
<span id="L113" class="LineNr">113 </span>
<span id="L114" class="LineNr">114 </span>Function:  This entry point commits the current transaction.  Any
<span id="L115" class="LineNr">115 </span>modifications made to DM files since the transaction began become
<span id="L116" class="LineNr">116 </span>permanent and visible to other transactions, as if all the changes were
<span id="L117" class="LineNr">117 </span>made in the same instant.
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>Syntax:
<span id="L121" class="LineNr">121 </span>declare transaction_manager_$commit_txn entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L122" class="LineNr">122 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L123" class="LineNr">123 </span>call transaction_manager_$commit_txn <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>Arguments:
<span id="L127" class="LineNr">127 </span>txn_id
<span id="L128" class="LineNr">128 </span>   is the identifier of the current transaction, or &quot;0&quot;b to default to
<span id="L129" class="LineNr">129 </span>   the current transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If txn_id is neither &quot;0&quot;b nor the
<span id="L130" class="LineNr">130 </span>   transaction identifier of the current transaction,
<span id="L131" class="LineNr">131 </span>   dm_error_$transaction_not_current is returned.  This argument can be
<span id="L132" class="LineNr">132 </span>   used as a check to be sure which transaction is being committed.
<span id="L133" class="LineNr">133 </span>code
<span id="L134" class="LineNr">134 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>Notes:  This entry point will retry commit of a transaction that was
<span id="L138" class="LineNr">138 </span>left in an error state by a previous commit.  It will not, however,
<span id="L139" class="LineNr">139 </span>attempt to commit a transaction left in error by any other operation.
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>
<span id="L142" class="LineNr">142 </span>:Entry: get_current_ids: 03/15/85 transaction_manager_$get_current_ids
<span id="L143" class="LineNr">143 </span>
<span id="L144" class="LineNr">144 </span>
<span id="L145" class="LineNr">145 </span>Function:  This entry point returns the identifier of the current
<span id="L146" class="LineNr">146 </span>transaction, the most recent checkpoint number, and the number of times
<span id="L147" class="LineNr">147 </span>this transaction has been rolled back.
<span id="L148" class="LineNr">148 </span>
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>Syntax:
<span id="L151" class="LineNr">151 </span>declare transaction_manager_$get_current_ids entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span>aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L152" class="LineNr">152 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L153" class="LineNr">153 </span>call transaction_manager_$get_current_ids <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> checkpoint_id<span class="textRainbow_lv0_o0">,</span>
<span id="L154" class="LineNr">154 </span>     rollback_count<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span>Arguments:
<span id="L158" class="LineNr">158 </span>txn_id
<span id="L159" class="LineNr">159 </span>   is the identifier of the current transaction.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L160" class="LineNr">160 </span>checkpoint_id
<span id="L161" class="LineNr">161 </span>   is the number of the most recent checkpoint.  This value is
<span id="L162" class="LineNr">162 </span>   currently always zero.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L163" class="LineNr">163 </span>rollback_count
<span id="L164" class="LineNr">164 </span>   is the number of times this transaction has been rolled back.
<span id="L165" class="LineNr">165 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L166" class="LineNr">166 </span>code
<span id="L167" class="LineNr">167 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L168" class="LineNr">168 </span>
<span id="L169" class="LineNr">169 </span>
<span id="L170" class="LineNr">170 </span>:Entry: get_current_txn_id: 03/15/85 transaction_manager_$get_current_txn_id
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>Function:  This entry point returns the identifier of the current
<span id="L174" class="LineNr">174 </span>transaction, and tells whether the transaction is suspended or in
<span id="L175" class="LineNr">175 </span>error.
<span id="L176" class="LineNr">176 </span>
<span id="L177" class="LineNr">177 </span>
<span id="L178" class="LineNr">178 </span>Syntax:
<span id="L179" class="LineNr">179 </span>declare transaction_manager_$get_current_txn_id entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L180" class="LineNr">180 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L181" class="LineNr">181 </span>call transaction_manager_$get_current_txn_id <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L182" class="LineNr">182 </span>
<span id="L183" class="LineNr">183 </span>
<span id="L184" class="LineNr">184 </span>Arguments:
<span id="L185" class="LineNr">185 </span>txn_id
<span id="L186" class="LineNr">186 </span>   is the identifier of the current transaction.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L187" class="LineNr">187 </span>code
<span id="L188" class="LineNr">188 </span>   is one of the codes listed below.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L189" class="LineNr">189 </span>
<span id="L190" class="LineNr">190 </span>
<span id="L191" class="LineNr">191 </span>:Entry: get_state_description: 03/15/85 transaction_manager_$get_state_description
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>
<span id="L194" class="LineNr">194 </span>Function:  This entry point generates a character string description of
<span id="L195" class="LineNr">195 </span>a numeric state returned by transaction_manager_$get_txn_info or
<span id="L196" class="LineNr">196 </span>transaction_manager_$get_txn_info_index.
<span id="L197" class="LineNr">197 </span>
<span id="L198" class="LineNr">198 </span>
<span id="L199" class="LineNr">199 </span>Syntax:
<span id="L200" class="LineNr">200 </span>declare transaction_manager_$get_state_description entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>
<span id="L201" class="LineNr">201 </span>     returns <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L202" class="LineNr">202 </span>state_description = transaction_manager_$get_state_description <span class="textRainbow_lv0_p0">(</span>state<span class="textRainbow_lv0_p0">)</span>;
<span id="L203" class="LineNr">203 </span>
<span id="L204" class="LineNr">204 </span>
<span id="L205" class="LineNr">205 </span>:Entry:  get_tdt_size:  03/15/85 transaction_manager_$get_tdt_size
<span id="L206" class="LineNr">206 </span>
<span id="L207" class="LineNr">207 </span>
<span id="L208" class="LineNr">208 </span>Function:  This entry point returns the number of entries allocated in
<span id="L209" class="LineNr">209 </span>the TDT.  This number can be used as an upper bound for looping through
<span id="L210" class="LineNr">210 </span>all TDT entries.
<span id="L211" class="LineNr">211 </span>
<span id="L212" class="LineNr">212 </span>
<span id="L213" class="LineNr">213 </span>Syntax:
<span id="L214" class="LineNr">214 </span>dcl transaction_manager_$get_tdt_size entry returns <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>;
<span id="L215" class="LineNr">215 </span>number = txn_$get_tdt_size <span class="textRainbow_lv0_p0">()</span>;
<span id="L216" class="LineNr">216 </span>
<span id="L217" class="LineNr">217 </span>
<span id="L218" class="LineNr">218 </span>Arguments:
<span id="L219" class="LineNr">219 </span>   There are no arguments.
<span id="L220" class="LineNr">220 </span>
<span id="L221" class="LineNr">221 </span>
<span id="L222" class="LineNr">222 </span>:Entry:  get_tdt_index:  03/15/85 transaction_manager_$get_tdt_index
<span id="L223" class="LineNr">223 </span>
<span id="L224" class="LineNr">224 </span>
<span id="L225" class="LineNr">225 </span>Function:  This entry point returns the index of the TDT entry occupied
<span id="L226" class="LineNr">226 </span>by a specified transaction.
<span id="L227" class="LineNr">227 </span>
<span id="L228" class="LineNr">228 </span>
<span id="L229" class="LineNr">229 </span>Syntax:
<span id="L230" class="LineNr">230 </span>declare transaction_manager_$get_tdt_index entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L231" class="LineNr">231 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span> returns <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_p0">)</span>;
<span id="L232" class="LineNr">232 </span>txn_index = transaction_manager_$get_tdt_index <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L233" class="LineNr">233 </span>
<span id="L234" class="LineNr">234 </span>
<span id="L235" class="LineNr">235 </span>Arguments:
<span id="L236" class="LineNr">236 </span>txn_id
<span id="L237" class="LineNr">237 </span>   is the identifier of a transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If it is &quot;0&quot;b, the
<span id="L238" class="LineNr">238 </span>   current transaction is used.
<span id="L239" class="LineNr">239 </span>code
<span id="L240" class="LineNr">240 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span>
<span id="L243" class="LineNr">243 </span>Access required:
<span id="L244" class="LineNr">244 </span>The caller requires re access to dm_admin_gate_ to obtain the index of
<span id="L245" class="LineNr">245 </span>another user's transaction.
<span id="L246" class="LineNr">246 </span>
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>:Entry:  get_txn_info:  03/15/85 transaction_manager_$get_txn_info
<span id="L249" class="LineNr">249 </span>
<span id="L250" class="LineNr">250 </span>
<span id="L251" class="LineNr">251 </span>Function:  This entry point returns a structure containing all the
<span id="L252" class="LineNr">252 </span>information in the TDT about a transaction.
<span id="L253" class="LineNr">253 </span>
<span id="L254" class="LineNr">254 </span>
<span id="L255" class="LineNr">255 </span>Syntax:
<span id="L256" class="LineNr">256 </span>declare transaction_manager_$get_txn_info entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L257" class="LineNr">257 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L258" class="LineNr">258 </span>call transaction_manager_$get_txn_info <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> txn_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L259" class="LineNr">259 </span>
<span id="L260" class="LineNr">260 </span>
<span id="L261" class="LineNr">261 </span>Arguments:
<span id="L262" class="LineNr">262 </span>txn_id
<span id="L263" class="LineNr">263 </span>   is the identifier of a transaction, or &quot;0&quot;b to default to the
<span id="L264" class="LineNr">264 </span>   current transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L265" class="LineNr">265 </span>txn_info_ptr
<span id="L266" class="LineNr">266 </span>   is a pointer to the txn_info structure, declared in
<span id="L267" class="LineNr">267 </span>   dm_tm_txn_info.incl.pl1.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L268" class="LineNr">268 </span>code
<span id="L269" class="LineNr">269 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L270" class="LineNr">270 </span>
<span id="L271" class="LineNr">271 </span>
<span id="L272" class="LineNr">272 </span>Access required:
<span id="L273" class="LineNr">273 </span>The caller requires re access to dm_admin_gate_ to obtain information
<span id="L274" class="LineNr">274 </span>about another user's transaction.
<span id="L275" class="LineNr">275 </span>
<span id="L276" class="LineNr">276 </span>
<span id="L277" class="LineNr">277 </span>:Entry: get_txn_info_index: 03/15/85 transaction_manager_$get_txn_info_index
<span id="L278" class="LineNr">278 </span>
<span id="L279" class="LineNr">279 </span>
<span id="L280" class="LineNr">280 </span>Function:  This entry point returns the same information as
<span id="L281" class="LineNr">281 </span>transaction_manager_$get_txn_info but accepts the index of a TDT entry
<span id="L282" class="LineNr">282 </span>rather than a transaction identifier.  The transaction command, for
<span id="L283" class="LineNr">283 </span>example, calls this entry point with numbers 1 through
<span id="L284" class="LineNr">284 </span>transaction_manager_$get_tdt_size<span class="textRainbow_lv0_p0">()</span> to print information for the entire
<span id="L285" class="LineNr">285 </span>TDT.
<span id="L286" class="LineNr">286 </span>
<span id="L287" class="LineNr">287 </span>
<span id="L288" class="LineNr">288 </span>Syntax:
<span id="L289" class="LineNr">289 </span>declare transaction_manager_$get_txn_info_index entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L290" class="LineNr">290 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L291" class="LineNr">291 </span>call transaction_manager_$get_txn_info_index <span class="textRainbow_lv0_p0">(</span>txn_index<span class="textRainbow_lv0_o0">,</span> txn_info_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L292" class="LineNr">292 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L293" class="LineNr">293 </span>
<span id="L294" class="LineNr">294 </span>
<span id="L295" class="LineNr">295 </span>Arguments:
<span id="L296" class="LineNr">296 </span>txn_index
<span id="L297" class="LineNr">297 </span>   is the index of a TDT entry.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L298" class="LineNr">298 </span>txn_info_ptr
<span id="L299" class="LineNr">299 </span>   is a pointer to the txn_info structure, declared in
<span id="L300" class="LineNr">300 </span>   dm_tm_txn_info.incl.pl1.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L301" class="LineNr">301 </span>code
<span id="L302" class="LineNr">302 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L303" class="LineNr">303 </span>
<span id="L304" class="LineNr">304 </span>
<span id="L305" class="LineNr">305 </span>Access required:
<span id="L306" class="LineNr">306 </span>The caller requires re access to dm_admin_gate_ to obtain information
<span id="L307" class="LineNr">307 </span>about another user's transaction.
<span id="L308" class="LineNr">308 </span>
<span id="L309" class="LineNr">309 </span>
<span id="L310" class="LineNr">310 </span>:Entry: handle_conditions: 03/15/85 transaction_manager_$handle_conditions
<span id="L311" class="LineNr">311 </span>
<span id="L312" class="LineNr">312 </span>
<span id="L313" class="LineNr">313 </span>Function:  This entry point, intended to be called by &quot;any_other&quot;
<span id="L314" class="LineNr">314 </span>handlers in user programs, temporarily suspends the current transaction
<span id="L315" class="LineNr">315 </span>during an interruption caused by a signalled condition.  When invoked,
<span id="L316" class="LineNr">316 </span>it suspends the current transaction, allows the condition to propagate,
<span id="L317" class="LineNr">317 </span>and resumes the transaction when control returns.
<span id="L318" class="LineNr">318 </span>
<span id="L319" class="LineNr">319 </span>
<span id="L320" class="LineNr">320 </span>Syntax:
<span id="L321" class="LineNr">321 </span>declare transaction_manager_$handle_conditions entry <span class="textRainbow_lv0_p0">()</span>;
<span id="L322" class="LineNr">322 </span>call transaction_manager_$handle_conditions <span class="textRainbow_lv0_p0">()</span>;
<span id="L323" class="LineNr">323 </span>
<span id="L324" class="LineNr">324 </span>
<span id="L325" class="LineNr">325 </span>Arguments:
<span id="L326" class="LineNr">326 </span>   There are no arguments.
<span id="L327" class="LineNr">327 </span>
<span id="L328" class="LineNr">328 </span>
<span id="L329" class="LineNr">329 </span>:Entry:  kill_txn:  03/15/85 transaction_manager_$kill_txn
<span id="L330" class="LineNr">330 </span>
<span id="L331" class="LineNr">331 </span>
<span id="L332" class="LineNr">332 </span>Function:  This entry point is intended to be called by the owner of a
<span id="L333" class="LineNr">333 </span>transaction when the owner cannot end the transaction normally and does
<span id="L334" class="LineNr">334 </span>not want the daemon to try to abort it for reasons of efficiency.
<span id="L335" class="LineNr">335 </span>Killing a transaction can destroy the consistency of the databases
<span id="L336" class="LineNr">336 </span>changed during the transaction, and is therefore appropriate only if
<span id="L337" class="LineNr">337 </span>consistency is no longer an issue <span class="textRainbow_lv0_p0">(</span>for example<span class="textRainbow_lv0_o0">,</span> if the databases are to
<span id="L338" class="LineNr">338 </span>be deleted<span class="textRainbow_lv0_p0">)</span>.  As with $abandon_txn, calling this entry point frees the
<span id="L339" class="LineNr">339 </span>user to begin a new transaction.
<span id="L340" class="LineNr">340 </span>
<span id="L341" class="LineNr">341 </span>
<span id="L342" class="LineNr">342 </span>Syntax:
<span id="L343" class="LineNr">343 </span>declare transaction_manager_$kill_txn entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L344" class="LineNr">344 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L345" class="LineNr">345 </span>call transaction_manager_$kill_txn <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L346" class="LineNr">346 </span>
<span id="L347" class="LineNr">347 </span>
<span id="L348" class="LineNr">348 </span>Arguments:
<span id="L349" class="LineNr">349 </span>txn_id
<span id="L350" class="LineNr">350 </span>   is the identifier of the transaction to be killed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If it is
<span id="L351" class="LineNr">351 </span>   &quot;0&quot;b, the current transaction is used.
<span id="L352" class="LineNr">352 </span>code
<span id="L353" class="LineNr">353 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L354" class="LineNr">354 </span>
<span id="L355" class="LineNr">355 </span>
<span id="L356" class="LineNr">356 </span>Access required:
<span id="L357" class="LineNr">357 </span>The caller requires re access to dm_admin_gate_.
<span id="L358" class="LineNr">358 </span>
<span id="L359" class="LineNr">359 </span>
<span id="L360" class="LineNr">360 </span>:Entry:  resume_txn:  03/15/85 transaction_manager_$resume_txn
<span id="L361" class="LineNr">361 </span>
<span id="L362" class="LineNr">362 </span>
<span id="L363" class="LineNr">363 </span>Function:  This entry point reactivates a suspended transaction, once
<span id="L364" class="LineNr">364 </span>again allowing data operations on protected files.
<span id="L365" class="LineNr">365 </span>
<span id="L366" class="LineNr">366 </span>
<span id="L367" class="LineNr">367 </span>Syntax:
<span id="L368" class="LineNr">368 </span>declare transaction_manager_$resume_txn entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L369" class="LineNr">369 </span>call transaction_manager_$resume_txn <span class="textRainbow_lv0_p0">(</span>code<span class="textRainbow_lv0_p0">)</span>;
<span id="L370" class="LineNr">370 </span>
<span id="L371" class="LineNr">371 </span>
<span id="L372" class="LineNr">372 </span>Arguments:
<span id="L373" class="LineNr">373 </span>code
<span id="L374" class="LineNr">374 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L375" class="LineNr">375 </span>
<span id="L376" class="LineNr">376 </span>
<span id="L377" class="LineNr">377 </span>:Entry:  rollback_txn:  03/15/85 transaction_manager_$rollback_txn
<span id="L378" class="LineNr">378 </span>
<span id="L379" class="LineNr">379 </span>
<span id="L380" class="LineNr">380 </span>Function:  This entry point rolls the current transaction back to its
<span id="L381" class="LineNr">381 </span>beginning, by replacing all modifications to protected files caused by
<span id="L382" class="LineNr">382 </span>the transaction, with the before images preserved in the appropriate
<span id="L383" class="LineNr">383 </span>before journal.  The transaction remains current for the user process.
<span id="L384" class="LineNr">384 </span>
<span id="L385" class="LineNr">385 </span>
<span id="L386" class="LineNr">386 </span>Syntax:
<span id="L387" class="LineNr">387 </span>declare transaction_manager_$rollback_txn entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>36<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L388" class="LineNr">388 </span>     bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L389" class="LineNr">389 </span>call transaction_manager_$rollback_txn <span class="textRainbow_lv0_p0">(</span>txn_id<span class="textRainbow_lv0_o0">,</span> checkpoint_number<span class="textRainbow_lv0_o0">,</span>
<span id="L390" class="LineNr">390 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L391" class="LineNr">391 </span>
<span id="L392" class="LineNr">392 </span>
<span id="L393" class="LineNr">393 </span>Arguments:
<span id="L394" class="LineNr">394 </span>txn_id
<span id="L395" class="LineNr">395 </span>   is the identifier of the current transaction, or &quot;0&quot;b to default to
<span id="L396" class="LineNr">396 </span>   the current transaction.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> If txn_id is neither &quot;0&quot;b nor the
<span id="L397" class="LineNr">397 </span>   transaction identifier of the current transaction,
<span id="L398" class="LineNr">398 </span>   dm_error_$transaction_not_current is returned.  This argument can be
<span id="L399" class="LineNr">399 </span>   used as a check to be sure which transaction is being rolled back.
<span id="L400" class="LineNr">400 </span>checkpoint_number
<span id="L401" class="LineNr">401 </span>   must currently be 0.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L402" class="LineNr">402 </span>code
<span id="L403" class="LineNr">403 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L404" class="LineNr">404 </span>
<span id="L405" class="LineNr">405 </span>
<span id="L406" class="LineNr">406 </span>Notes:  This entry point will retry rollback of a transaction that was
<span id="L407" class="LineNr">407 </span>left in an error state by a previous rollback.  It will not attempt to
<span id="L408" class="LineNr">408 </span>rollback a transaction left in error by any other operation.
<span id="L409" class="LineNr">409 </span>
<span id="L410" class="LineNr">410 </span>
<span id="L411" class="LineNr">411 </span>:Entry:  suspend_txn:  03/15/85 transaction_manager_$suspend_txn
<span id="L412" class="LineNr">412 </span>
<span id="L413" class="LineNr">413 </span>
<span id="L414" class="LineNr">414 </span>Function:  This entry point puts the current transaction into a
<span id="L415" class="LineNr">415 </span>suspended state wherein it is temporarily unusable.  Data operations to
<span id="L416" class="LineNr">416 </span>protected files are not allowed while the transaction is suspended,
<span id="L417" class="LineNr">417 </span>that is, until $resume_txn is called.  Since the suspended transaction
<span id="L418" class="LineNr">418 </span>has not been completed, no new transaction can be begun.
<span id="L419" class="LineNr">419 </span>
<span id="L420" class="LineNr">420 </span>
<span id="L421" class="LineNr">421 </span>Syntax:
<span id="L422" class="LineNr">422 </span>declare transaction_manager_$suspend_txn entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L423" class="LineNr">423 </span>call transaction_manager_$suspend_txn <span class="textRainbow_lv0_p0">(</span>code<span class="textRainbow_lv0_p0">)</span>;
<span id="L424" class="LineNr">424 </span>
<span id="L425" class="LineNr">425 </span>
<span id="L426" class="LineNr">426 </span>Arguments:
<span id="L427" class="LineNr">427 </span>code
<span id="L428" class="LineNr">428 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L429" class="LineNr">429 </span>
<span id="L430" class="LineNr">430 </span>
<span id="L431" class="LineNr">431 </span>Notes:  Suspension has the following effects:
<span id="L432" class="LineNr">432 </span>
<span id="L433" class="LineNr">433 </span>1.   The current transaction is temporarily unusable.  As a result, the
<span id="L434" class="LineNr">434 </span>     entry point $get_current_txn_id returns &quot;0&quot;b and the error code
<span id="L435" class="LineNr">435 </span>     dm_error_$transaction_suspended.
<span id="L436" class="LineNr">436 </span>
<span id="L437" class="LineNr">437 </span>2.   No data operations on protected files are allowed while the
<span id="L438" class="LineNr">438 </span>     transaction is suspended.
<span id="L439" class="LineNr">439 </span>
<span id="L440" class="LineNr">440 </span>3.   Both $begin_txn and $commit_txn return
<span id="L441" class="LineNr">441 </span>     dm_error_$transaction_suspended.
<span id="L442" class="LineNr">442 </span>
<span id="L443" class="LineNr">443 </span>4.   Both $abort_txn and $adjust_tdt_entry <span class="textRainbow_lv0_p0">(</span>called by DMS<span class="textRainbow_lv0_p0">)</span> work on
<span id="L444" class="LineNr">444 </span>     suspended transactions.
<span id="L445" class="LineNr">445 </span>
<span id="L446" class="LineNr">446 </span>
<span id="L447" class="LineNr">447 </span>:Entry:  user_shutdown:  03/15/85  transaction_manager_$user_shutdown
<span id="L448" class="LineNr">448 </span>
<span id="L449" class="LineNr">449 </span>
<span id="L450" class="LineNr">450 </span>Function:
<span id="L451" class="LineNr">451 </span>This  entry  point  shuts  down  DMS  in the calling process.  All TDT entries
<span id="L452" class="LineNr">452 </span>belonging  to  the  caller's  Person.Project are adjusted before DMS is turned
<span id="L453" class="LineNr">453 </span>off.   If  the  calling  process  is not currently using DMS, the entry does a
<span id="L454" class="LineNr">454 </span>return.
<span id="L455" class="LineNr">455 </span>
<span id="L456" class="LineNr">456 </span>Information  about  the  adjusted  TDT  entries  is  returned in the structure
<span id="L457" class="LineNr">457 </span>tm_shutdown_info, declared in dm_tm_shutdown_info.incl.pl1.
<span id="L458" class="LineNr">458 </span>
<span id="L459" class="LineNr">459 </span>
<span id="L460" class="LineNr">460 </span>Syntax:
<span id="L461" class="LineNr">461 </span>dcl transaction_manager_$user_shutdown entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L462" class="LineNr">462 </span>    bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L463" class="LineNr">463 </span>call transaction_manager_$user_shutdown <span class="textRainbow_lv0_p0">(</span>area_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L464" class="LineNr">464 </span>    tm_shutdown_info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L465" class="LineNr">465 </span>
<span id="L466" class="LineNr">466 </span>
<span id="L467" class="LineNr">467 </span>Arguments:
<span id="L468" class="LineNr">468 </span>area_ptr
<span id="L469" class="LineNr">469 </span>   is a pointer to an area in which to allocate the shutdown_info
<span id="L470" class="LineNr">470 </span>   structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L471" class="LineNr">471 </span>tm_shutdown_info_ptr
<span id="L472" class="LineNr">472 </span>   is  the  returned pointer  to  tm_shutdown_info, found  in the
<span id="L473" class="LineNr">473 </span>   dm_tm_shutdown_info.incl.pl1 include file.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L474" class="LineNr">474 </span>code
<span id="L475" class="LineNr">475 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
